﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using WebGrid_EF_MVC.Models;

namespace WebGrid_Filter_DropDownList_MVC.Controllers
{
    public class HomeController : Controller
    {
        // GET: Home
        public ActionResult Index()
        {
            NorthwindModel model = PopulateModel(null);
            return View(model);

        }

        [HttpPost]
        public ActionResult Index(string country)
        {
            NorthwindModel model = PopulateModel(country);
            return View(model);
        }

        private static NorthwindModel PopulateModel(string country)
        {
            using (NorthwindEntities entities = new NorthwindEntities())
            {
                NorthwindModel model = new NorthwindModel()
                {
                    Customers = (from c in entities.Customers
                                 where c.Country == country || string.IsNullOrEmpty(country)
                                 select c).ToList(),
                    Countries = (from c in entities.Customers
                                 select new SelectListItem { Text = c.Country, Value = c.Country }).Distinct().ToList()
                };

                return model;
            }
        }
    }
}